// This file is to be included only - it does not do anything if
// executed directly

operator Reintegrate(m, m1, m2, m_m1, m_m2) {

  // Match m and m1
  (m_m1, multimap) = Match(m, m1, NGramMatch(m, m1));
  m_m1 = EditMap(m, m1, m_m1, multimap, "Mapping m_m1");

  // Match m and m2
  (m_m2, multimap) = Match(m, m2, NGramMatch(m, m2));
  m_m2 = EditMap(m, m2, m_m2, multimap, "Mapping m_m2");

  // Propagate deletions
  (m1', m1'_m1) = Delete(m1, Traverse(All(m) - Domain(m_m2), m_m1));
  (m2', m2'_m2) = Delete(m2, Traverse(All(m) - Domain(m_m1), m_m2));

  // Extract added elements only
  (m1x, m1x_m1') = Extract(m1', Traverse(All(m1) - Range(m_m1), Invert(m1'_m1)));
  (m2x, m2x_m2') = Extract(m2', Traverse(All(m2) - Range(m_m2), Invert(m2'_m2)));

  m1x_m2x = m1x_m1' * m1'_m1 * Invert(m_m1) * m_m2 * Invert(m2'_m2) * Invert(m2x_m2');
  // Alternatively, we may run the semiautomatic matcher
  //(m1x_m2x, multimap) = Match(m1x, m2x, NGramMatch(m1x, m2x));

  m1x_m2x = EditMap(m1x, m2x, m1x_m2x, multimap, "Match the additions! (m1x_m2x)");

  m1'_m2' = Invert(m1x_m1') * m1x_m2x * m2x_m2' + m1'_m1 * Invert(m_m1) * m_m2 * Invert(m2'_m2);

  (m3, m1'_m3, m2'_m3) = Merge(m1', m2', m1'_m2');

  m1_m3 = Invert(m1'_m1) * m1'_m3;
  m2_m3 = Invert(m2'_m2) * m2'_m3;
  m_m3 = m_m1 * m1_m3 + m_m2 * m2_m3;

  EditMap(m, m3, m_m3, null, "Final result: m_m3");

  return (m3, m_m3, m1_m3, m2_m3);
}



// Same as above but showing more popup windows
operator ReintegrateVerbose(m, m1, m2) {

  // Match m and m1
  (m_m1, multimap) = Match(m, m1, NGramMatch(m, m1));
  m_m1 = EditMap(m, m1, m_m1, multimap, "Mapping m_m1");

  // Match m and m2
  (m_m2, multimap) = Match(m, m2, NGramMatch(m, m2));
  m_m2 = EditMap(m, m2, m_m2, multimap, "Mapping m_m2");

  // Propagate deletions
  m1_del = Traverse(All(m) - Domain(m_m2), m_m1);
  	m1_del = EditSelector(m1, m1_del, "Elements to be deleted from m1");
  (m1', m1'_m1) = Delete(m1, m1_del);
  	popup(m1', Obj2Text, "m1' = m1 without the deleted elements");

  m2_del = Traverse(All(m) - Domain(m_m1), m_m2);
  	m2_del = EditSelector(m2, m2_del, "Elements to be deleted from m2");
  (m2', m2'_m2) = Delete(m2, m2_del);
  	popup(m2', Obj2Text, "m2' = m2 without the deleted elements");

  // Extract added elements only
  m1'_add = Traverse(All(m1) - Range(m_m1), Invert(m1'_m1));
  	m1'_add = EditSelector(m1', m1'_add, "Elements added in m1'");
  (m1x, m1x_m1') = Extract(m1', m1'_add);
  	popup(m1x, Obj2Text, "m1x = added elements of m1' and their support elements");

  m2'_add = Traverse(All(m2) - Range(m_m2), Invert(m2'_m2));
  	m2'_add = EditSelector(m2', m2'_add, "Elements added in m2'");
  (m2x, m2x_m2') = Extract(m2', m2'_add);
  	popup(m2x, Obj2Text, "m2x = added elements of m2' and their support elements");

  m1x_m2x = m1x_m1' * m1'_m1 * Invert(m_m1) * m_m2 * Invert(m2'_m2) * Invert(m2x_m2');
  m1x_m2x = EditMap(m1x, m2x, m1x_m2x, multimap, "Match the additions! (m1x_m2x)");

  m1'_m2' = Invert(m1x_m1') * m1x_m2x * m2x_m2' + m1'_m1 * Invert(m_m1) * m_m2 * Invert(m2'_m2);

  (m3, m1'_m3, m2'_m3) = Merge(m1', m2', m1'_m2');

  m1_m3 = Invert(m1'_m1) * m1'_m3;
  m2_m3 = Invert(m2'_m2) * m2'_m3;
  m_m3 = m_m1 * m1_m3 + m_m2 * m2_m3;

  EditMap(m, m3, m_m3, null, "Final result: m_m3");

  return (m3, m_m3, m1_m3, m2_m3);
}
